## gbsplay 0.0.94+git20210915

=== Makefile ===
.PHONY: all default distclean clean install dist clean-apidoc

all: default

noincludes  := $(patsubst distclean,yes,$(MAKECMDGOALS))

# Defaults, overridden by config.mk below once configure has run
prefix      := /usr/local
exec_prefix := $(prefix)

bindir       := $(exec_prefix)/bin
libdir       := $(exec_prefix)/lib
mandir       := $(prefix)/man
docdir       := $(prefix)/share/doc/gbsplay
localedir    := $(prefix)/share/locale
mimedir      := $(prefix)/share/mime
appdir       := $(prefix)/share/applications
includedir   := $(prefix)/include/libgbs
pkgconfigdir := $(prefix)/share/pkgconfig

configured := no
ifneq ($(noincludes),yes)
-include config.mk
endif

ifeq ($(use_verbosebuild),yes)
  VERBOSE = 1
endif
ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif
ifeq ($(VERBOSE),1)
  Q =
else
  Q = @
endif

generatedeps := no
ifneq ($(noincludes),yes)
ifeq ($(configured),yes)
generatedeps := yes
endif
endif

XMMSPREFIX  :=
DESTDIR     :=

# Update paths with user-provided DESTDIR
prefix       := $(DESTDIR)$(prefix)
exec_prefix  := $(DESTDIR)$(exec_prefix)
bindir       := $(DESTDIR)$(bindir)
mandir       := $(DESTDIR)$(mandir)
docdir       := $(DESTDIR)$(docdir)
localedir    := $(DESTDIR)$(localedir)
mimedir      := $(DESTDIR)$(mimedir)
appdir       := $(DESTDIR)$(appdir)
includedir   := $(DESTDIR)$(includedir)
pkgconfigdir := $(DESTDIR)$(pkgconfigdir)

xmmsdir     := $(DESTDIR)$(XMMSPREFIX)$(XMMS_INPUT_PLUGIN_DIR)

man1dir     := $(mandir)/man1
man3dir     := $(mandir)/man3
man5dir     := $(mandir)/man5
contribdir  := $(docdir)/contrib
exampledir  := $(docdir)/examples

DISTDIR := gbsplay-$(VERSION)

GBSCFLAGS  := $(EXTRA_CFLAGS)
GBSLDFLAGS := $(EXTRA_LDFLAGS)
comma := ,
GBSLIBLDFLAGS := -lm $(subst -pie,,$(subst -Wl$(comma)-pie,,$(EXTRA_LDFLAGS)))
# Additional ldflags for the gbsplay executable
GBSPLAYLDFLAGS :=
# Additional ldflags for the xgbsplay executable
XGBSPLAYLDFLAGS := -lxcb -lxcb-icccm -lcairo

EXTRA_CLEAN :=

export Q VERBOSE CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS

docs               := README.md HISTORY COPYRIGHT
docs-dist          := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
examples           := examples/nightmode.gbs examples/gbsplayrc_sample

mans               := man/gbsplay.1    man/gbsinfo.1    man/gbsplayrc.5
mans_src           := man/gbsplay.in.1 man/gbsinfo.in.1 man/gbsplayrc.in.5

apimans_list       := libgbs.h gbs gbs_channel_status gbs_output_buffer gbs_status
apidocdir          := apidoc
apimans            := $(patsubst %,$(apidocdir)/man/man3/%.3,$(apimans_list))

apiheaders         := libgbs.h

objs_libgbspic     := gbcpu.lo gbhw.lo mapper.lo gbs.lo crc32.lo
objs_libgbs        := gbcpu.o  gbhw.o  mapper.o  gbs.o  crc32.o
objs_gbs2gb        := gbs2gb.o
objs_gbsinfo       := gbsinfo.o
objs_gbsxmms       := gbsxmms.lo
objs_gbsplay       := gbsplay.o  util.o plugout.o player.o cfgparser.o
objs_xgbsplay      := xgbsplay.o util.o plugout.o player.o cfgparser.o
objs_test_gbs      := test_gbs.o
objs_gen_impulse_h := gen_impulse_h.ho impulsegen.ho

tests              := util.test impulsegen.test

# terminal handling
ifeq ($(windows_libprefix),lib)
# when on MINGW
objs_gbsplay += terminal_windows.o
else
objs_gbsplay += terminal_posix.o
endif

# gbsplay output plugins
plugout_objs    :=
plugout_ldflags :=

ifeq ($(plugout_devdsp),yes)
plugout_objs +=plugout_devdsp.o
endif
ifeq ($(plugout_alsa),yes)
plugout_objs +=plugout_alsa.o
plugout_ldflags += -lasound
endif
ifeq ($(plugout_nas),yes)
plugout_objs +=plugout_nas.o
plugout_ldflags += -laudio $(libaudio_flags)
endif
ifeq ($(plugout_sdl),yes)
plugout_objs +=plugout_sdl.o
plugout_ldflags += -lSDL2
endif
ifeq ($(plugout_stdout),yes)
plugout_objs +=plugout_stdout.o
endif
ifeq ($(plugout_midi),yes)
plugout_objs +=plugout_midi.o
endif
ifeq ($(plugout_altmidi),yes)
plugout_objs +=plugout_altmidi.o
endif
ifeq ($(plugout_pulse),yes)
plugout_objs +=plugout_pulse.o
plugout_ldflags += -lpulse-simple -lpulse
endif
ifeq ($(plugout_dsound),yes)
plugout_objs +=plugout_dsound.o
plugout_ldflags += -ldsound $(libdsound_flags)
endif
ifeq ($(plugout_iodumper),yes)
plugout_objs +=plugout_iodumper.o
endif

objs_gbsplay +=$(plugout_objs)
objs_xgbsplay += $(plugout_objs)
GBSPLAYLDFLAGS += $(plugout_ldflags)
XGBSPLAYLDFLAGS += $(plugout_ldflags)

# install contrib files?
ifeq ($(build_contrib),yes)
EXTRA_INSTALL += install-contrib
EXTRA_UNINSTALL += uninstall-contrib
endif

# test built binary?
ifeq ($(build_test),yes)
TEST_TARGETS += test
endif

# Cygwin automatically adds .exe to binaries.
# We should notice that or we can't rm the files later!
ifeq ($(windows_build),yes)
binsuffix         := .exe
else
binsuffix         :=
endif
gbsplaybin        := gbsplay$(binsuffix)
xgbsplaybin       := xgbsplay$(binsuffix)
gbs2gbbin         := gbs2gb$(binsuffix)
gbsinfobin        := gbsinfo$(binsuffix)
test_gbsbin       := test_gbs$(binsuffix)
gen_impulse_h_bin := gen_impulse_h$(binsuffix)

ifeq ($(use_sharedlibgbs),yes)

EXTRA_INSTALL += install-headers install-pkg-config
EXTRA_UNINSTALL += uninstall-headers uninstall-pkg-config

ifeq ($(have_doxygen),yes)
EXTRA_INSTALL += install-apidoc
EXTRA_UNINSTALL += uninstall-apidoc
endif

GBSLDFLAGS += -L. -lgbs
objs += $(objs_libgbspic)

libgbs.so.1.ver: libgbs_whitelist.txt gen_linkercfg.sh
	./gen_linkercfg.sh libgbs_whitelist.txt $@ ver

libgbs.def: libgbs_whitelist.txt gen_linkercfg.sh
	./gen_linkercfg.sh libgbs_whitelist.txt $@ def

ifeq ($(windows_build),yes)
EXTRA_INSTALL += install-$(windows_libprefix)gbs-1.dll
EXTRA_UNINSTALL += uninstall-$(windows_libprefix)gbs-1.dll

install-$(windows_libprefix)gbs-1.dll:
	install -d $(bindir)
	install -d $(libdir)
	install -m 644 $(windows_libprefix)gbs-1.dll $(bindir)/$(windows_libprefix)gbs-1.dll
	install -m 644 libgbs.dll.a $(libdir)/libgbs.dll.a

uninstall-$(windows_libprefix)gbs-1.dll:
	rm -f $(bindir)/$(windows_libprefix)gbs-1.dll
	rm -f $(libdir)/libgbs.dll.a
	-rmdir -p $(libdir)

$(windows_libprefix)gbs-1.dll: $(objs_libgbspic) libgbs.so.1.ver
	$(CC) -fpic -shared -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)

libgbs.dll.a: libgbs.def
	dlltool --input-def libgbs.def --dllname $(windows_libprefix)gbs-1.dll --output-lib libgbs.dll.a -k

libgbs: $(windows_libprefix)gbs-1.dll libgbs.dll.a
	touch libgbs

libgbspic: $(windows_libprefix)gbs-1.dll libgbs.dll.a
	touch libgbspic
else
EXTRA_INSTALL += install-libgbs.so.1
EXTRA_UNINSTALL += uninstall-libgbs.so.1


install-libgbs.so.1:
	install -d $(libdir)
	install -m 644 libgbs.so.1 $(libdir)/libgbs.so.1

uninstall-libgbs.so.1:
	rm -f $(libdir)/libgbs.so.1
	-rmdir -p $(libdir)


libgbs.so.1: $(objs_libgbspic) libgbs.so.1.ver
	$(BUILDCC) -fpic -shared -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic) $(GBSLIBLDFLAGS)
	ln -fs $@ libgbs.so

libgbs: libgbs.so.1
	touch libgbs

libgbspic: libgbs.so.1
	touch libgbspic
endif
else
GBSLDFLAGS += -lm
objs += $(objs_libgbs)
objs_gbsplay += libgbs.a
objs_gbs2gb += libgbs.a
objs_gbsinfo += libgbs.a
objs_test_gbs += libgbs.a
ifeq ($(build_xmmsplugin),yes)
objs += $(objs_libgbspic)
objs_gbsxmms += libgbspic.a
endif # build_xmmsplugin
objs_xgbsplay += libgbs.a

libgbs: libgbs.a
	touch libgbs

libgbspic: libgbspic.a
	touch libgbspic
endif # use_sharedlibs

objs += $(objs_gbsplay) $(ojbs_gbs2gb) $(objs_gbsinfo)
dsts += gbsplay gbs2gb gbsinfo

ifeq ($(build_xmmsplugin),yes)
objs += $(objs_gbsxmms)
dsts += gbsxmms.so
endif

ifeq ($(build_xgbsplay),yes)
objs += $(objs_xgbsplay)
dsts += xgbsplay
mans += man/xgbsplay.1
mans_src += man/xgbsplay.in.1
EXTRA_INSTALL += install-xgbsplay
EXTRA_UNINSTALL += uninstall-xgbsplay
EXTRA_CLEAN += clean-xgbsplay
endif

# include the rules for each subdir
include $(shell find . -type f -name "subdir.mk")

ifeq ($(generatedeps),yes)
# Ready to build deps and everything else
default: config.mk $(objs) $(dsts) $(mans) $(EXTRA_ALL) $(TEST_TARGETS)

# Generate & include the dependency files
deps := $(patsubst %.o,%.d,$(filter %.o,$(objs)))
deps += $(patsubst %.lo,%.d,$(filter %.lo,$(objs)))
-include $(deps)
else
# Configure still needs to run
default: config.mk
endif

distclean: clean
	find . -regex ".*\.d" -exec rm -f "{}" \;
	rm -f ./config.mk ./config.h ./config.err ./config.sed ./libgbs.pc

clean: clean-default $(EXTRA_CLEAN) clean-apidoc

clean-default:
	find . -regex ".*\.\([aos]\|ho\|lo\|mo\|pot\|test\(\.exe\)?\|so\(\.[0-9]\)?\|gcda\|gcno\|gcov\)" -exec rm -f "{}" \;
	find . -name "*~" -exec rm -f "{}" \;
	rm -f libgbs libgbspic libgbs.def libgbs.so.1.ver
	rm -f $(mans)
	rm -f $(gbsplaybin) $(gbs2gbbin) $(gbsinfobin)
	rm -f $(test_gbsbin)
	rm -f $(gen_impulse_h_bin) impulse.h

clean-apidoc:
	rm -rf $(apidocdir)/

clean-xgbsplay:
	rm -f $(xgbsplaybin)

install: all install-default $(EXTRA_INSTALL)

install-default:
	install -d $(bindir)
	install -d $(man1dir)
	install -d $(man5dir)
	install -d $(docdir)
	install -d $(exampledir)
	install -d $(mimedir)/packages
	install -d $(appdir)
	install -m 755 $(gbsplaybin) $(gbs2gbbin) $(gbsinfobin) $(bindir)
	install -m 644 man/gbsplay.1 man/gbsinfo.1 $(man1dir)
	install -m 644 man/gbsplayrc.5 $(man5dir)
	install -m 644 mime/gbsplay.xml $(mimedir)/packages
	-update-mime-database $(mimedir)
	install -m 644 desktop/gbsplay.desktop $(appdir)
	-update-desktop-database $(appdir)
	install -m 644 $(docs) $(docdir)
	install -m 644 $(examples) $(exampledir)
	for i in $(mos); do \
		base=`basename $$i`; \
		install -d $(localedir)/$${base%.mo}/LC_MESSAGES; \
		install -m 644 $$i $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
	done

install-contrib:
	install -d $(contribdir)
	install -m 644 $(contribs) $(contribdir)

install-gbsxmms.so:
	install -d $(xmmsdir)
	install -m 644 gbsxmms.so $(xmmsdir)/gbsxmms.so

install-xgbsplay:
	install -d $(bindir)
	install -d $(man1dir)
	install -m 755 $(xgbsplaybin) $(bindir)
	install -m 644 man/xgbsplay.1 $(man1dir)
	install -m 644 desktop/xgbsplay.desktop $(appdir)
	-update-desktop-database $(appdir)

install-apidoc:	generate-apidoc
	install -d $(man3dir)
	install -m 644 $(apimans) $(man3dir)

install-headers:
	install -d $(includedir)
	install -m 644 $(apiheaders) $(includedir)

install-pkg-config:
	install -d $(pkgconfigdir)
	install -m 644 libgbs.pc $(pkgconfigdir)

uninstall: uninstall-default $(EXTRA_UNINSTALL)

uninstall-default:
	rm -f $(bindir)/$(gbsplaybin) $(bindir)/$(gbs2gbbin) $(bindir)/$(gbsinfobin)
	-rmdir -p $(bindir)
	rm -f $(man1dir)/gbsplay.1 $(man1dir)/gbsinfo.1
	-rmdir -p $(man1dir)
	rm -f $(man5dir)/gbsplayrc.5
	-rmdir -p $(man5dir)
	rm -f $(mimedir)/packages/gbsplay.xml
	-update-mime-database $(mimedir)
	-rmdir -p $(mimedir)/packages
	rm -f $(appdir)/gbsplay.desktop
	-update-desktop-database $(appdir)
	-rmdir -p $(appdir)
	rm -rf $(exampledir)
	-rmdir -p $(exampledir)
	rm -rf $(docdir)
	-mkdir -p $(docdir)
	-rmdir -p $(docdir)
	-for i in $(mos); do \
		base=`basename $$i`; \
		rm -f $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
		rmdir -p $(localedir)/$${base%.mo}/LC_MESSAGES; \
	done

uninstall-contrib:
	rm -rf $(contribdir)
	-rmdir -p $(contribdir)

uninstall-gbsxmms.so:
	rm -f $(xmmsdir)/gbsxmms.so
	-rmdir -p $(xmmsdir)

uninstall-xgbsplay:
	rm -f $(bindir)/$(xgbsplaybin)
	rm -f $(man1dir)/xgbsplay.1
	rm -f $(appdir)/xgbsplay.desktop
	-update-desktop-database $(appdir)
	-rmdir -p $(bindir)
	-rmdir -p $(man1dir)
	-rmdir -p $(appdir)

uninstall-apidoc:
	rm -f $(patsubst %, $(man3dir)/%.3,$(apimans_list))
	-rmdir -p $(man3dir)

uninstall-headers:
	rm -f $(addprefix $(includedir)/,$(apiheaders))
	-rmdir -p $(includedir)

uninstall-pkg-config:
	rm -f $(pkgconfigdir)/libgbs.pc
	-rmdir -p $(pkgconfigdir)

dist:	distclean
	install -d ./$(DISTDIR)
	sed 's/^VERSION=.*/VERSION=$(VERSION)/' < configure > ./$(DISTDIR)/configure
	chmod 755 ./$(DISTDIR)/configure
	install -m 755 depend.sh ./$(DISTDIR)/
	install -m 644 Makefile ./$(DISTDIR)/
	install -m 644 *.c ./$(DISTDIR)/

=== debian/changelog ===
gbsplay (0.0.94+git20210915-1) unstable; urgency=medium

  * New upstream version.
  * d/rules:
    - add --enable-verbosebuild to ./configure. (Closes: #977943)
    - also build and install xgbsplay.
  * d/clean: added.
  * d/control: add libsdl2-dev, libxcb-icccm4-dev, libcairo2-dev to
    build-depends.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 15 Sep 2021 11:43:17 +0200

=== debian/control ===
Source: gbsplay
Section: sound
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Uploaders: Christian Garbs <debian@cgarbs.de>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), gettext, libaudio-dev, libpulse-dev, libasound2-dev, libsdl2-dev, libxcb-icccm4-dev, libcairo2-dev
Homepage: https://github.com/mmitch/gbsplay

Package: gbsplay
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: vorbis-tools
Description: Gameboy sound player
 This program emulates the sound hardware of the Nintendo Gameboy.  It
 is able to play the sounds from a Gameboy module dump (.GBS format).
 Also included is the gbsinfo tool which displays information about
 a .GBS file.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -W

override_dh_auto_configure:
	./configure \
	--enable-verbosebuild \
	--prefix=/usr \
	--exec-prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--sysconfdir=/etc \
	--datadir=\$${prefix}/share/gbsplay \
	--bindir=\$${prefix}/bin \
	--infodir=\$${prefix}/share/info \
	--with-xgbsplay \
	--without-xmmsplugin \
	--enable-nas --enable-midi --enable-devdsp --enable-stdout --enable-alsa --enable-pulse \
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install
	-rm -r debian/gbsplay/usr/share/mime/aliases debian/gbsplay/usr/share/mime/generic-icons debian/gbsplay/usr/share/mime/globs debian/gbsplay/usr/share/mime/globs2 debian/gbsplay/usr/share/mime/icons debian/gbsplay/usr/share/mime/magic debian/gbsplay/usr/share/mime/mime.cache debian/gbsplay/usr/share/mime/subclasses debian/gbsplay/usr/share/mime/treemagic debian/gbsplay/usr/share/mime/types debian/gbsplay/usr/share/mime/version debian/gbsplay/usr/share/mime/XMLnamespaces debian/gbsplay/usr/share/mime/audio debian/gbsplay/usr/share/applications/*.cache

override_dh_auto_test:
	@echo SKIPPING TESTS, SEE https://github.com/mmitch/gbsplay/issues/62

%:
	dh $@ --no-parallel

## gbsplay 0.0.96

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,8 @@
+MAKEFLAGS += --warn-undefined-variables
+.DELETE_ON_ERROR:
+SHELL := bash
+.SHELLFLAGS := -eu -o pipefail -c
+
 .PHONY: all default distclean clean install dist clean-apidoc
 
 all: default
@@ -45,7 +50,7 @@
 endif
 endif
 
-XMMSPREFIX  :=
+TEST_WRAPPER =
 DESTDIR     :=
 
 # Update paths with user-provided DESTDIR
@@ -60,8 +65,6 @@
 includedir   := $(DESTDIR)$(includedir)
 pkgconfigdir := $(DESTDIR)$(pkgconfigdir)
 
-xmmsdir     := $(DESTDIR)$(XMMSPREFIX)$(XMMS_INPUT_PLUGIN_DIR)
-
 man1dir     := $(mandir)/man1
 man3dir     := $(mandir)/man3
 man5dir     := $(mandir)/man5
@@ -70,7 +73,7 @@
 
 DISTDIR := gbsplay-$(VERSION)
 
-GBSCFLAGS  := $(EXTRA_CFLAGS)
+GBSCFLAGS  := -D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=200809L $(EXTRA_CFLAGS)
 GBSLDFLAGS := $(EXTRA_LDFLAGS)
 comma := ,
 GBSLIBLDFLAGS := -lm $(subst -pie,,$(subst -Wl$(comma)-pie,,$(EXTRA_LDFLAGS)))
@@ -84,7 +87,7 @@
 export Q VERBOSE CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
 
 docs               := README.md HISTORY COPYRIGHT
-docs-dist          := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
+docs-dist          := INSTALL.md CODINGSTYLE gbsformat.txt
 contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
 examples           := examples/nightmode.gbs examples/gbsplayrc_sample
 
@@ -101,7 +104,6 @@
 objs_libgbs        := gbcpu.o  gbhw.o  mapper.o  gbs.o  crc32.o
 objs_gbs2gb        := gbs2gb.o
 objs_gbsinfo       := gbsinfo.o
-objs_gbsxmms       := gbsxmms.lo
 objs_gbsplay       := gbsplay.o  util.o plugout.o player.o cfgparser.o
 objs_xgbsplay      := xgbsplay.o util.o plugout.o player.o cfgparser.o
 objs_test_gbs      := test_gbs.o
@@ -122,42 +124,55 @@
 plugout_ldflags :=
 
 ifeq ($(plugout_devdsp),yes)
-plugout_objs +=plugout_devdsp.o
+plugout_objs += plugout_devdsp.o
 endif
 ifeq ($(plugout_alsa),yes)
-plugout_objs +=plugout_alsa.o
+plugout_objs += plugout_alsa.o
 plugout_ldflags += -lasound
 endif
 ifeq ($(plugout_nas),yes)
-plugout_objs +=plugout_nas.o
+plugout_objs += plugout_nas.o
 plugout_ldflags += -laudio $(libaudio_flags)
 endif
 ifeq ($(plugout_sdl),yes)
-plugout_objs +=plugout_sdl.o
-plugout_ldflags += -lSDL2
+plugout_objs += plugout_sdl.o
+plugout_ldflags += $(libSDL2_flags)
 endif
 ifeq ($(plugout_stdout),yes)
-plugout_objs +=plugout_stdout.o
+plugout_objs += plugout_stdout.o
 endif
 ifeq ($(plugout_midi),yes)
-plugout_objs +=plugout_midi.o
+plugout_objs += plugout_midi.o midifile.o filewriter.o
 endif
 ifeq ($(plugout_altmidi),yes)
-plugout_objs +=plugout_altmidi.o
+plugout_objs += plugout_altmidi.o midifile.o filewriter.o
+endif
+ifeq ($(plugout_pipewire),yes)
+plugout_objs += plugout_pipewire.o
+plugout_ldflags += $(libpipewire_0_3_flags)
 endif
 ifeq ($(plugout_pulse),yes)
-plugout_objs +=plugout_pulse.o
+plugout_objs += plugout_pulse.o
 plugout_ldflags += -lpulse-simple -lpulse
 endif
 ifeq ($(plugout_dsound),yes)
-plugout_objs +=plugout_dsound.o
+plugout_objs += plugout_dsound.o
 plugout_ldflags += -ldsound $(libdsound_flags)
 endif
 ifeq ($(plugout_iodumper),yes)
-plugout_objs +=plugout_iodumper.o
-endif
-
-objs_gbsplay +=$(plugout_objs)
+plugout_objs += plugout_iodumper.o
+endif
+ifeq ($(plugout_wav),yes)
+plugout_objs +=plugout_wav.o filewriter.o
+endif
+ifeq ($(plugout_vgm),yes)
+plugout_objs += plugout_vgm.o filewriter.o
+endif
+
+# dedupe (and finalize) plugout_objs; order is irrelevant, sorting is ok
+plugout_objs := $(sort $(plugout_objs))
+
+objs_gbsplay += $(plugout_objs)
 objs_xgbsplay += $(plugout_objs)
 GBSPLAYLDFLAGS += $(plugout_ldflags)
 XGBSPLAYLDFLAGS += $(plugout_ldflags)
@@ -263,10 +278,6 @@
 objs_gbs2gb += libgbs.a
 objs_gbsinfo += libgbs.a
 objs_test_gbs += libgbs.a
-ifeq ($(build_xmmsplugin),yes)
-objs += $(objs_libgbspic)
-objs_gbsxmms += libgbspic.a
-endif # build_xmmsplugin
 objs_xgbsplay += libgbs.a
 
 libgbs: libgbs.a
@@ -278,11 +289,6 @@
 
 objs += $(objs_gbsplay) $(ojbs_gbs2gb) $(objs_gbsinfo)
 dsts += gbsplay gbs2gb gbsinfo
-
-ifeq ($(build_xmmsplugin),yes)
-objs += $(objs_gbsxmms)
-dsts += gbsxmms.so
-endif
 
 ifeq ($(build_xgbsplay),yes)
 objs += $(objs_xgbsplay)
@@ -359,10 +365,6 @@
 install-contrib:
 	install -d $(contribdir)
 	install -m 644 $(contribs) $(contribdir)
-
-install-gbsxmms.so:
-	install -d $(xmmsdir)
-	install -m 644 gbsxmms.so $(xmmsdir)/gbsxmms.so
 
 install-xgbsplay:
 	install -d $(bindir)
@@ -414,10 +416,6 @@
 	rm -rf $(contribdir)
 	-rmdir -p $(contribdir)
 
-uninstall-gbsxmms.so:
-	rm -f $(xmmsdir)/gbsxmms.so
-	-rmdir -p $(xmmsdir)
-
 uninstall-xgbsplay:
 	rm -f $(bindir)/$(xgbsplaybin)
 	rm -f $(man1dir)/xgbsplay.1
@@ -442,7 +440,3 @@
 dist:	distclean
 	install -d ./$(DISTDIR)
 	sed 's/^VERSION=.*/VERSION=$(VERSION)/' < configure > ./$(DISTDIR)/configure
-	chmod 755 ./$(DISTDIR)/configure
-	install -m 755 depend.sh ./$(DISTDIR)/
-	install -m 644 Makefile ./$(DISTDIR)/
-	install -m 644 *.c ./$(DISTDIR)/

=== debian/changelog ===
gbsplay (0.0.96-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:13:58 +0000

gbsplay (0.0.96-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:34:55 +0000

gbsplay (0.0.96-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 06:36:31 +0000

gbsplay (0.0.96-1) unstable; urgency=medium

  * New upstream version.
  * Bump standard version to 4.6.2.
  * Update maintainer address.
  * d/copyright: bump years.
  * d/control: add Vcs fields.
  * d/gbsplay.desktop: dropped, using upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 05 Feb 2024 13:53:05 +0100

gbsplay (0.0.95-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 05 Feb 2024 13:46:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,21 @@
 Source: gbsplay
 Section: sound
 Priority: optional
-Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
-Uploaders: Christian Garbs <debian@cgarbs.de>
-Standards-Version: 4.5.0
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Uploaders: Gürkan Myczko <tar@debian.org>, Christian Garbs <debian@cgarbs.de>
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13), gettext, libaudio-dev, libpulse-dev, libasound2-dev, libsdl2-dev, libxcb-icccm4-dev, libcairo2-dev
+Vcs-Git: https://salsa.debian.org/multimedia-team/gbsplay.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/gbsplay
+Build-Depends: debhelper-compat (= 13),
+ gettext,
+ libaudio-dev,
+ libpulse-dev,
+ libasound2-dev,
+ libsdl2-dev,
+ libxcb-icccm4-dev,
+ libcairo2-dev
 Homepage: https://github.com/mmitch/gbsplay
 
 Package: gbsplay

## gbsplay 0.0.97

=== Makefile ===
--- 
+++ 
@@ -100,8 +100,8 @@
 
 apiheaders         := libgbs.h
 
-objs_libgbspic     := gbcpu.lo gbhw.lo mapper.lo gbs.lo crc32.lo
-objs_libgbs        := gbcpu.o  gbhw.o  mapper.o  gbs.o  crc32.o
+objs_libgbspic     := gbcpu.lo gbhw.lo gblfsr.lo mapper.lo gbs.lo crc32.lo
+objs_libgbs        := gbcpu.o  gbhw.o  gblfsr.o  mapper.o  gbs.o  crc32.o
 objs_gbs2gb        := gbs2gb.o
 objs_gbsinfo       := gbsinfo.o
 objs_gbsplay       := gbsplay.o  util.o plugout.o player.o cfgparser.o
@@ -109,7 +109,7 @@
 objs_test_gbs      := test_gbs.o
 objs_gen_impulse_h := gen_impulse_h.ho impulsegen.ho
 
-tests              := util.test impulsegen.test
+tests              := util.test impulsegen.test gblfsr.test
 
 # terminal handling
 ifeq ($(windows_libprefix),lib)
@@ -439,4 +439,3 @@
 
 dist:	distclean
 	install -d ./$(DISTDIR)
-	sed 's/^VERSION=.*/VERSION=$(VERSION)/' < configure > ./$(DISTDIR)/configure

=== debian/changelog ===
gbsplay (0.0.97-1) unstable; urgency=medium

  * New upstream version.
  * Bump standard version to 4.7.0.
  * Update my name.

 -- Alex Myczko <tar@debian.org>  Tue, 23 Apr 2024 06:03:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: gbsplay
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: Gürkan Myczko <tar@debian.org>, Christian Garbs <debian@cgarbs.de>
-Standards-Version: 4.6.2
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Uploaders: Alex Myczko <tar@debian.org>, Christian Garbs <debian@cgarbs.de>
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/gbsplay.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/gbsplay

## gbsplay 0.0.99

=== Makefile ===
--- 
+++ 
@@ -86,9 +86,9 @@
 
 export Q VERBOSE CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
 
-docs               := README.md HISTORY COPYRIGHT
+docs               := README.md HISTORY COPYRIGHT LICENCE
 docs-dist          := INSTALL.md CODINGSTYLE gbsformat.txt
-contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
+contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion contrib/gbsplay.zshcompletion
 examples           := examples/nightmode.gbs examples/gbsplayrc_sample
 
 mans               := man/gbsplay.1    man/gbsinfo.1    man/gbsplayrc.5
@@ -109,7 +109,7 @@
 objs_test_gbs      := test_gbs.o
 objs_gen_impulse_h := gen_impulse_h.ho impulsegen.ho
 
-tests              := util.test impulsegen.test gblfsr.test
+tests              := util.test impulsegen.test gblfsr.test cfgparser.test
 
 # terminal handling
 ifeq ($(windows_libprefix),lib)
@@ -328,7 +328,7 @@
 	rm -f libgbs libgbspic libgbs.def libgbs.so.1.ver
 	rm -f $(mans)
 	rm -f $(gbsplaybin) $(gbs2gbbin) $(gbsinfobin)
-	rm -f $(test_gbsbin)
+	rm -f $(test_gbsbin) gbsplayrc.tmp
 	rm -f $(gen_impulse_h_bin) impulse.h
 
 clean-apidoc:
@@ -438,4 +438,3 @@
 	-rmdir -p $(pkgconfigdir)
 
 dist:	distclean
-	install -d ./$(DISTDIR)

=== examples/sdcc/Makefile ===
SDCC ?= sdcc
MAKEBIN ?= makebin
SDCCFLAGS := -mgbz80 --code-loc 0x400 --opt-code-size

all: test.gb test.gbs

clean:
	rm -f *.ihx *.map *.rel *.noi *.gb *.gbs *.sym *.lk *.lst *.asm

%.ihx: %.c
	$(SDCC) $(SDCCFLAGS) $<

%.gb: %.ihx
	$(MAKEBIN) -Z -yn TEST $< $@

%.img: %.ihx
	$(MAKEBIN) -Z -p -yn TEST $< $@

%.gbs: %.img
	./makegbs.py -r $< -s $(subst .img,.noi,$<) -o $@

=== debian/changelog ===
gbsplay (0.0.99-2) unstable; urgency=medium

  * Team Upload
  * Add patch fro GCC-15 (Closes: #1114113)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 24 Sep 2025 20:43:50 +0200

gbsplay (0.0.99-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Fri, 28 Mar 2025 08:13:13 +0000

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,6 @@
 	--bindir=\$${prefix}/bin \
 	--infodir=\$${prefix}/share/info \
 	--with-xgbsplay \
-	--without-xmmsplugin \
 	--enable-nas --enable-midi --enable-devdsp --enable-stdout --enable-alsa --enable-pulse \
 	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

## gbsplay 0.0.102

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 SHELL := bash
 .SHELLFLAGS := -eu -o pipefail -c
 
-.PHONY: all default distclean clean install dist clean-apidoc
+.PHONY: all default distclean clean install dist clean-apidoc show-install-dirs
 
 all: default
 
@@ -56,6 +56,7 @@
 # Update paths with user-provided DESTDIR
 prefix       := $(DESTDIR)$(prefix)
 exec_prefix  := $(DESTDIR)$(exec_prefix)
+libdir       := $(DESTDIR)$(libdir)
 bindir       := $(DESTDIR)$(bindir)
 mandir       := $(DESTDIR)$(mandir)
 docdir       := $(DESTDIR)$(docdir)
@@ -87,12 +88,11 @@
 export Q VERBOSE CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
 
 docs               := README.md HISTORY COPYRIGHT LICENCE
-docs-dist          := INSTALL.md CODINGSTYLE gbsformat.txt
+docs-dist          := INSTALL.md CODINGSTYLE gbsformat.txt PACKAGING.md
 contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion contrib/gbsplay.zshcompletion
 examples           := examples/nightmode.gbs examples/gbsplayrc_sample
 
-mans               := man/gbsplay.1    man/gbsinfo.1    man/gbsplayrc.5
-mans_src           := man/gbsplay.in.1 man/gbsinfo.in.1 man/gbsplayrc.in.5
+mans               := man/gbsplay.1    man/gbsinfo.1    man/gbsplayrc.5    man/gbs2gb.1
 
 apimans_list       := libgbs.h gbs gbs_channel_status gbs_output_buffer gbs_status
 apidocdir          := apidoc
@@ -185,7 +185,9 @@
 
 # test built binary?
 ifeq ($(build_test),yes)
-TEST_TARGETS += test
+TEST_TARGETS = test
+else
+TEST_TARGETS =
 endif
 
 # Cygwin automatically adds .exe to binaries.
@@ -287,14 +289,13 @@
 	touch libgbspic
 endif # use_sharedlibs
 
-objs += $(objs_gbsplay) $(ojbs_gbs2gb) $(objs_gbsinfo)
+objs += $(objs_gbsplay) $(objs_gbs2gb) $(objs_gbsinfo)
 dsts += gbsplay gbs2gb gbsinfo
 
 ifeq ($(build_xgbsplay),yes)
 objs += $(objs_xgbsplay)
 dsts += xgbsplay
 mans += man/xgbsplay.1
-mans_src += man/xgbsplay.in.1
 EXTRA_INSTALL += install-xgbsplay
 EXTRA_UNINSTALL += uninstall-xgbsplay
 EXTRA_CLEAN += clean-xgbsplay
@@ -316,7 +317,7 @@
 default: config.mk
 endif
 
-distclean: clean
+distclean: clean clean-xgbsplay
 	find . -regex ".*\.d" -exec rm -f "{}" \;
 	rm -f ./config.mk ./config.h ./config.err ./config.sed ./libgbs.pc
 
@@ -337,9 +338,9 @@
 clean-xgbsplay:
 	rm -f $(xgbsplaybin)
 
-install: all install-default $(EXTRA_INSTALL)
-
-install-default:
+install: install-default $(EXTRA_INSTALL)
+
+install-default: all
 	install -d $(bindir)
 	install -d $(man1dir)
 	install -d $(man5dir)
@@ -348,7 +349,7 @@
 	install -d $(mimedir)/packages
 	install -d $(appdir)
 	install -m 755 $(gbsplaybin) $(gbs2gbbin) $(gbsinfobin) $(bindir)
-	install -m 644 man/gbsplay.1 man/gbsinfo.1 $(man1dir)
+	install -m 644 man/gbsplay.1 man/gbsinfo.1 man/gbs2gb.1 $(man1dir)
 	install -m 644 man/gbsplayrc.5 $(man5dir)
 	install -m 644 mime/gbsplay.xml $(mimedir)/packages
 	-update-mime-database $(mimedir)
@@ -366,9 +367,10 @@
 	install -d $(contribdir)
 	install -m 644 $(contribs) $(contribdir)
 
-install-xgbsplay:
+install-xgbsplay: $(xgbsplaybin) $(mans)
 	install -d $(bindir)
 	install -d $(man1dir)
+	install -d $(appdir)
 	install -m 755 $(xgbsplaybin) $(bindir)
 	install -m 644 man/xgbsplay.1 $(man1dir)
 	install -m 644 desktop/xgbsplay.desktop $(appdir)
@@ -386,12 +388,34 @@
 	install -d $(pkgconfigdir)
 	install -m 644 libgbs.pc $(pkgconfigdir)
 
+show-install-dirs:
+	@echo "+ DESTDIR      = $(DESTDIR)"
+	@echo "* bindir       = $(bindir)"
+	@echo "  includedir   = $(includedir)"
+	@echo "* libdir       = $(libdir)"
+	@echo "* mandir       = $(mandir)"
+	@echo "  man1dir      = $(man1dir)"
+	@echo "  man3dir      = $(man3dir)"
+	@echo "  man5dir      = $(man5dir)"
+	@echo "* appdir       = $(appdir)"
+	@echo "* docdir       = $(docdir)"
+	@echo "  contribdir   = $(contribdir)"
+	@echo "  exampledir   = $(exampledir)"
+	@echo "  localedir    = $(localedir)"
+	@for i in $(mos); do \
+		base=`basename $$i`; \
+		echo "                 $(localedir)/$${base%.mo}"; \
+	done
+	@echo "  mimedir      = $(mimedir)"
+	@echo "                 $(mimedir)/packages"
+	@echo "  pkgconfigdir = $(pkgconfigdir)"
+
 uninstall: uninstall-default $(EXTRA_UNINSTALL)
 
 uninstall-default:
 	rm -f $(bindir)/$(gbsplaybin) $(bindir)/$(gbs2gbbin) $(bindir)/$(gbsinfobin)
 	-rmdir -p $(bindir)
-	rm -f $(man1dir)/gbsplay.1 $(man1dir)/gbsinfo.1
+	rm -f $(man1dir)/gbsplay.1 $(man1dir)/gbsinfo.1 $(man1dir)/gbs2gb.1
 	-rmdir -p $(man1dir)
 	rm -f $(man5dir)/gbsplayrc.5
 	-rmdir -p $(man5dir)
@@ -402,39 +426,3 @@
 	-update-desktop-database $(appdir)
 	-rmdir -p $(appdir)
 	rm -rf $(exampledir)
-	-rmdir -p $(exampledir)
-	rm -rf $(docdir)
-	-mkdir -p $(docdir)
-	-rmdir -p $(docdir)
-	-for i in $(mos); do \
-		base=`basename $$i`; \
-		rm -f $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
-		rmdir -p $(localedir)/$${base%.mo}/LC_MESSAGES; \
-	done
-
-uninstall-contrib:
-	rm -rf $(contribdir)
-	-rmdir -p $(contribdir)
-
-uninstall-xgbsplay:
-	rm -f $(bindir)/$(xgbsplaybin)
-	rm -f $(man1dir)/xgbsplay.1
-	rm -f $(appdir)/xgbsplay.desktop
-	-update-desktop-database $(appdir)
-	-rmdir -p $(bindir)
-	-rmdir -p $(man1dir)
-	-rmdir -p $(appdir)
-
-uninstall-apidoc:
-	rm -f $(patsubst %, $(man3dir)/%.3,$(apimans_list))
-	-rmdir -p $(man3dir)
-
-uninstall-headers:
-	rm -f $(addprefix $(includedir)/,$(apiheaders))
-	-rmdir -p $(includedir)
-
-uninstall-pkg-config:
-	rm -f $(pkgconfigdir)/libgbs.pc
-	-rmdir -p $(pkgconfigdir)
-
-dist:	distclean

=== debian/changelog ===
gbsplay (0.0.102-1) unstable; urgency=medium

  * New upstream version. (Closes: #1105835)
  * d/copyright: bump years.
  * d/patches: lost.

 -- Alex Myczko <tar@debian.org>  Fri, 14 Nov 2025 20:46:40 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Alex Myczko <tar@debian.org>, Christian Garbs <debian@cgarbs.de>
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/multimedia-team/gbsplay.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/gbsplay
 Build-Depends: debhelper-compat (= 13),

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gbsplay-$1\.tar\.gz/ \
  https://github.com/mmitch/gbsplay/tags .*/(\d\S*)\.tar\.gz
